/****************************************************************
 * This software is Copyright (C) 1986-1998 by                  *
 *                                                              *
 * F6FBB - Jean-Paul ROUBELAT,  jpr@f6fbb.org                   *
 * 6, rue George Sand                                           *
 * 31120 - Roquettes - France                                   *
 *                                                              *
 * License to copy and use this software is granted for         *
 * non-commercial use provided that it is identified as         *
 *                                                              *
 * "FBB packet-radio BBS software by Jean-Paul ROUBELAT, F6FBB" *
 *                                                              *
 * in all material mentioning or referencing this software      *
 * or this function.                                            *
 *                                                              *
 * These notices must be retained in any copies of any part of  *
 * this documentation and/or software.                          *
 *                                                              *
 * Parts of code have been taken from many other softwares.     *
 * Thanks for the help.                                         *
 ****************************************************************/

/*
 * Fichier des variables locales
 */

#define ENGLISH

#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/Separator.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/ToggleB.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/ScrollBar.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/MessageB.h>
#include <Xm/FileSB.h>
#include <Xm/ComboBox.h>

#define IDOK                1
#define IDCANCEL            0
#define IDYES               1
#define IDNO                2

#define MB_OK               0x0000
#define MB_OKCANCEL         0x0001
#define MB_YESNOCANCEL      0x0003
#define MB_YESNO            0x0004

#define MB_ICONHAND         0x0010
#define MB_ICONQUESTION     0x0020
#define MB_ICONEXCLAMATION  0x0030
#define MB_ICONASTERISK     0x0040
#define MB_ICONINFORMATION  MB_ICONASTERISK

#define ED_MESSAGE 1
#define ED_EDITMSG 2

#define SEPARATOR 0
#define BUTTON 1
#define TOGGLE 2
#define TOOLBUTTON 3

#ifndef PUBLIC
#define PUBLIC extern
#endif

PUBLIC XtAppContext app_context;

PUBLIC XmRendition r_rend[10];
PUBLIC int r_index;

PUBLIC FILE *p_fptr;

PUBLIC Pixel df_pixel;
PUBLIC Pixel rf_pixel;
PUBLIC Pixel vf_pixel;
PUBLIC Pixel bf_pixel;
PUBLIC Pixel no_pixel;
PUBLIC Pixel rc_pixel;
PUBLIC Pixel vc_pixel;
PUBLIC Pixel bc_pixel;

PUBLIC Widget toplevel;
PUBLIC Widget form;
PUBLIC Widget pb;
PUBLIC Widget MenuBar;
PUBLIC Widget MenuFile;
PUBLIC Widget MenuUser;
PUBLIC Widget MenuEdit;
PUBLIC Widget MenuWindow;
PUBLIC Widget MenuOptions;
PUBLIC Widget MenuConfig;
PUBLIC Widget MenuPactor;
PUBLIC Widget MenuHelp;
PUBLIC Widget ToolBar;
PUBLIC Widget Jauge;

PUBLIC Widget ListForm;
PUBLIC Widget ConnectLabel;
PUBLIC Widget StatForm;
PUBLIC Widget StatusLabel;
PUBLIC Widget ConnectList;
PUBLIC Widget ConnectString;
PUBLIC Widget StatList;

PUBLIC Widget Footer;
PUBLIC int foothelp;

PUBLIC int editoron;

#define NB_ICON 16
PUBLIC Widget BIcon[NB_ICON];

#define NB_INIT_B 11
PUBLIC Widget Tb[NB_INIT_B];

PUBLIC Widget ScanSys;
PUBLIC Widget ScanMsg;

/* Liste des widgets de status */
PUBLIC Widget TxtUsed;
PUBLIC Widget TxtGMem;
PUBLIC Widget TxtDisk1;
PUBLIC Widget TxtDisk2;
PUBLIC Widget TxtMsgs;
PUBLIC Widget TxtResync;
PUBLIC Widget TxtState;
PUBLIC Widget TxtHold;
PUBLIC Widget TxtPriv;

PUBLIC Widget Used;
PUBLIC Widget GMem;
PUBLIC Widget Disk1;
PUBLIC Widget Disk2;
PUBLIC Widget Msgs;
PUBLIC Widget Resync;
PUBLIC Widget State;
PUBLIC Widget Hold;
PUBLIC Widget Priv;

PUBLIC Widget Popup;

PUBLIC Widget Opt[10];

#define NB_PITEM 5
PUBLIC Widget PItem[NB_PITEM];

PUBLIC int CurrentSelection;

int MessageBox(int, char *, char *, int);

void cursor_wait(void);
void disconnect_channel(int, int);
void end_wait(void);
void FbbRequestUserList (void);
void EditMsgCB(Widget, XtPointer, XtPointer);
void EditUsrCB(Widget, XtPointer, XtPointer);
void ListCnxCB(Widget, XtPointer, XtPointer);
void PendingCB(Widget, XtPointer, XtPointer);
void AboutDialog(Widget, XtPointer, XtPointer);
void CopyDialog(Widget, XtPointer, XtPointer);
void InfoDialog(Widget, XtPointer, XtPointer);
void CallsignDialog(Widget, XtPointer, XtPointer);

void EditMessage(Widget);
void EditUser(Widget);
void ListCnx(Widget);
void PendingForward(Widget);

void LabelSetString(Widget, char *, char *);

void ShowFbbWindow(int, Widget);
void sysop_end(void);

void DisplayInfoDialog(int);

void CreateEditor(char *file, char *preload, char *title, 
		  int options, int autow);

Widget add_item(int type, Widget menu_pane, char *nom, 
		XtCallbackProc callback, XtPointer data, 
		char *help, XtEventHandler HelpCB);
